## widelands 16

=== CMakeLists.txt ===
project (widelands)

cmake_minimum_required (VERSION 2.6)

# Used as versioning, if WL_VERSION_STANDARD is definded.
if (WL_VERSION_STANDARD)
	# Set the values below for standard versioning.
	# As long as WL_VERSION_MAJOR is 0, the naming will be in form of
	# "Build${WL_VERSION_MINOR}" + ".${WL_VERSION_PATCH}" if WL_VERSION_PATCH is
	# defined.
	set (WL_VERSION_MAJOR 0)
	set (WL_VERSION_MINOR 15)

	# Just define in case that we release patches for official builds
	#set (WL_VERSION_PATCH 90)

	# An addition to the version name (e.g. RC1, DEV, ...)
	set (WL_VERSION_ADDITION DEV)
endif (WL_VERSION_STANDARD)

# Define the directory structure for installation - will be hardcoded in WL bin
# If nothing is given on command line, set the standard values depending on platform.

if (WIN32 OR APPLE OR WL_PORTABLE)
  if (NOT WL_INSTALL_PREFIX OR WL_INSTALL_PREFIX STREQUAL "")
    set (WL_INSTALL_PREFIX ".")
  endif (NOT WL_INSTALL_PREFIX OR WL_INSTALL_PREFIX STREQUAL "")

  if (NOT WL_INSTALL_DATADIR OR WL_INSTALL_DATADIR STREQUAL "")
    set (WL_INSTALL_DATADIR ".")
  endif (NOT WL_INSTALL_DATADIR OR WL_INSTALL_DATADIR STREQUAL "")

  if (NOT WL_INSTALL_LOCALEDIR OR WL_INSTALL_LOCALEDIR STREQUAL "")
    set (WL_INSTALL_LOCALEDIR "locale")
  endif (NOT WL_INSTALL_LOCALEDIR OR WL_INSTALL_LOCALEDIR STREQUAL "")

  if (NOT WL_INSTALL_BINDIR OR WL_INSTALL_BINDIR STREQUAL "")
    set (WL_INSTALL_BINDIR ".")
  endif (NOT WL_INSTALL_BINDIR OR WL_INSTALL_BINDIR STREQUAL "")
elseif (WIN32 OR APPLE OR WL_PORTABLE)
  if (NOT WL_INSTALL_PREFIX OR WL_INSTALL_PREFIX STREQUAL "")
    set (WL_INSTALL_PREFIX "/usr/local")
  endif (NOT WL_INSTALL_PREFIX OR WL_INSTALL_PREFIX STREQUAL "")

  if (NOT WL_INSTALL_DATADIR OR WL_INSTALL_DATADIR STREQUAL "")
    set (WL_INSTALL_DATADIR "share/games/widelands")
  endif (NOT WL_INSTALL_DATADIR OR WL_INSTALL_DATADIR STREQUAL "")

  if (NOT WL_INSTALL_LOCALEDIR OR WL_INSTALL_LOCALEDIR STREQUAL "")
    set (WL_INSTALL_LOCALEDIR "${WL_INSTALL_PREFIX}/${WL_INSTALL_DATADIR}/locale")
  endif (NOT WL_INSTALL_LOCALEDIR OR WL_INSTALL_LOCALEDIR STREQUAL "")

  if (NOT WL_INSTALL_BINDIR OR WL_INSTALL_BINDIR STREQUAL "")
    set (WL_INSTALL_BINDIR "games")
  endif (NOT WL_INSTALL_BINDIR OR WL_INSTALL_BINDIR STREQUAL "")
endif (WIN32 OR APPLE OR WL_PORTABLE)

# General install prefix for config.h
if (NOT WL_INSTALL_PREFIX OR WL_INSTALL_PREFIX STREQUAL "")
	set (WL_INSTALL_PREFIX /usr/local)
endif (NOT WL_INSTALL_PREFIX OR WL_INSTALL_PREFIX STREQUAL "")

# Widelands binary directory
if (NOT WL_INSTALL_BINDIR OR WL_INSTALL_BINDIR STREQUAL "")
	set (WL_INSTALL_BINDIR games)
endif (NOT WL_INSTALL_BINDIR OR WL_INSTALL_BINDIR STREQUAL "")

# Widelands data directory
if (NOT WL_INSTALL_DATADIR OR WL_INSTALL_DATADIR STREQUAL "")
	set (WL_INSTALL_DATADIR share/games/widelands)
endif (NOT WL_INSTALL_DATADIR OR WL_INSTALL_DATADIR STREQUAL "")

# Widelands locale directory
if (NOT WL_INSTALL_LOCALEDIR OR WL_INSTALL_LOCALEDIR STREQUAL "")
	set (WL_INSTALL_LOCALEDIR ${WL_INSTALL_PREFIX}/${WL_INSTALL_DATADIR}/locale)
endif (NOT WL_INSTALL_LOCALEDIR OR WL_INSTALL_LOCALEDIR STREQUAL "")

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "Build-directory and source-directory are the same!")
endif (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

if (CMAKE_INSTALL_PREFIX STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "Build-directory and install-directory are the same!")
endif (CMAKE_INSTALL_PREFIX STREQUAL CMAKE_BINARY_DIR)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)

if (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
  find_path(FILE_WL_RELEASE "WL_RELEASE" ${CMAKE_CURRENT_SOURCE_DIR})
  if (${FILE_WL_RELEASE} STREQUAL "FILE_WL_RELEASE-NOTFOUND")
    set (CMAKE_BUILD_TYPE Debug)
  else (${FILE_WL_RELEASE} STREQUAL "FILE_WL_RELEASE-NOTFOUND")
    set (CMAKE_BUILD_TYPE Release)
  endif (${FILE_WL_RELEASE} STREQUAL "FILE_WL_RELEASE-NOTFOUND")
endif (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")

set (CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE})

# Unit tests are built per default in Debug and not build in Release
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  option (WL_UNIT_TESTS "build and run unit tests (requires boost_unit_test_framework)" ON)
else (CMAKE_BUILD_TYPE STREQUAL "Debug")
  option (WL_UNIT_TESTS "build and run unit tests (requires boost_unit_test_framework)" OFF)
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")

# we only include Boost Headers to the main executable, no libraries
# unit_test_framework is for testing only
if (WL_UNIT_TESTS)
  message(STATUS "Enabled unit tests")

  set (BUILD_SHARED_LIBS OFF)
  set (Boost_FIND_COMPONENTS unit_test_framework)
  set (Boost_USE_STATIC_LIBS   ON)
  set (Boost_USE_MULTITHREADED ON)
  set (Boost_DETAILED_FAILURE_MSG ON)
  find_package(Boost 1.35.0 COMPONENTS unit_test_framework REQUIRED)

  if (NOT DEFINED MSVC)
    string( REGEX MATCH ".a$" BOOST_STATIC_UNIT_TEST_LIB ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
    if (NOT BOOST_STATIC_UNIT_TEST_LIB)
      add_definitions(-DBOOST_TEST_DYN_LINK)
    endif (NOT BOOST_STATIC_UNIT_TEST_LIB)
  endif(NOT DEFINED MSVC)

  include(CTest)
  enable_testing()

  #automatic unit testing hook, must be updated to reflect all tests
  #if this is too intricate, we can also have this as an automatic detection
  #but the current way allows to disable certain checks if they are taking
  #too much time when ran every compile time
  add_custom_target(autotest ALL
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    DEPENDS widelands;test_widelands_scripting
  )
else (WL_UNIT_TESTS)
  message(STATUS "Disabled Unit Tests")
  find_package(Boost 1.35.0 REQUIRED)
endif (WL_UNIT_TESTS)

option (WL_STRICT "If strict compilation mode is requested (almost every warning is an error)" OFF)

set (PARAMETER_COMPILERFLAG_OLDSTYLECAST_EXTENDED "-Wold-style-cast -isystem ${Boost_INCLUDE_DIR}")
set (PARAMETER_COMPILERFLAG_OLDSTYLECAST "-Wold-style-cast")
set (PARAMETER_COMPILERFLAG_GENERICWARNINGS "-Wno-attributes -Wall")
set (PARAMETER_COMPILERFLAG_EXTRAWARNINGS "-Wextra -Wsign-promo")
set (PARAMETER_COMPILERFLAG_STRICT "-Werror -Wno-error=old-style-cast -Wno-error=deprecated-declarations -fdiagnostics-show-option")
IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
  include(CheckCXXCompilerFlag) #this include should be safe
  CHECK_CXX_COMPILER_FLAG(${PARAMETER_COMPILERFLAG_OLDSTYLECAST_EXTENDED} Compiler_old-style-cast_supported)
  IF (Compiler_old-style-cast_supported)
    EXEC_PROGRAM(${CMAKE_CXX_COMPILER}
      ARGS --version
      OUTPUT_VARIABLE WLBUILD_COMPILERVERSION
    )
    STRING(REGEX REPLACE ".*([0-9])\\.([0-9])\\.([0-9]).*" "\\1.\\2.\\3" WLBUILD_COMPILERVERSION_REP ${WLBUILD_COMPILERVERSION})
    IF (WLBUILD_COMPILERVERSION_REP STREQUAL "4.3.2" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.3.1")
      message("===== ATTENTION ===================================================")
      message("Your compiler has been identified as GCC 4.3.1 or GCC 4.3.2")
      message(" ")
      message("There is a bug regarding this version, see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38000")
      message("and https://bugs.launchpad.net/widelands/+bug/549479 for details.")
      message("Build will disable -isystem usage, expect lots of warnings from Boost header files.")
      message("Widelands should still compile and link correctly.")
      message("If the compiler identification is correct, please consider updating your gcc.")
      message("This warning message will disappear at GCC 4.3.3 and higher.")
      message("If you feel this is wrong, please submit a bug with widelands (not with GCC!)")
      message("and add the following information how cmake sees your C++ compiler:")
      message(" ")
      message("--------------------------------")
      message("${WLBUILD_COMPILERVERSION}")
      message("--------------------------------")
      message(" ")
      message("Thank you for taking your time to read this.")
      message("===================================================================")
      set (WL_COMPILERFLAG_OLDSTYLECAST " ${PARAMETER_COMPILERFLAG_OLDSTYLECAST}") #the space is on purpose!
    ELSE (WLBUILD_COMPILERVERSION_REP STREQUAL "4.3.2" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.3.1")
      set (WL_COMPILERFLAG_OLDSTYLECAST " ${PARAMETER_COMPILERFLAG_OLDSTYLECAST_EXTENDED}") #the space is on purpose!
    ENDIF (WLBUILD_COMPILERVERSION_REP STREQUAL "4.3.2" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.3.1")
  ENDIF (Compiler_old-style-cast_supported)

  CHECK_CXX_COMPILER_FLAG(${PARAMETER_COMPILERFLAG_GENERICWARNINGS} Compiler_generic_warnings_supported)
  IF (Compiler_generic_warnings_supported)
    set (WL_COMPILERFLAG_GENERICWARNINGS " ${PARAMETER_COMPILERFLAG_GENERICWARNINGS}") #the space is on purpose!
  ENDIF (Compiler_generic_warnings_supported)
  IF (WL_EXTRAWARNINGS)
    CHECK_CXX_COMPILER_FLAG(${PARAMETER_COMPILERFLAG_EXTRAWARNINGS} Compiler_extra_warnings_supported)
    IF (Compiler_extra_warnings_supported)
      set (WL_COMPILERFLAG_EXTRAWARNINGS " ${PARAMETER_COMPILERFLAG_EXTRAWARNINGS}") #the space is on purpose!
    ENDIF (Compiler_extra_warnings_supported)
  ENDIF (WL_EXTRAWARNINGS)

  IF (WL_STRICT)
    CHECK_CXX_COMPILER_FLAG(${PARAMETER_COMPILERFLAG_STRICT} Compiler_strict_mode_supported)
    IF (Compiler_strict_mode_supported)
      set (WL_COMPILERFLAG_STRICT " ${PARAMETER_COMPILERFLAG_STRICT}") #the space is on purpose!
      message(STATUS "Strict mode enabled, expect compilation errors instead of compilation warnings!")
    ENDIF (Compiler_strict_mode_supported)
  ENDIF (WL_STRICT)
ENDIF (CMAKE_BUILD_TYPE STREQUAL "Debug")

# CMAKE only defines "-g", but we need -DDEBUG also, and we need -DNOPARACHUTE (for SDL) in Debug
set (CMAKE_CXX_FLAGS_DEBUG "-g -DDEBUG -DNOPARACHUTE${WL_COMPILERFLAG_OLDSTYLECAST}${WL_COMPILERFLAG_GENERICWARNINGS}${WL_COMPILERFLAG_EXTRAWARNINGS}${WL_COMPILERFLAG_STRICT}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)

# CMAKE defines "-O3 -DNDEBUG", but we better say -O2 (see gcc manual)
set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)

#If building with MSVC, then check for 3rdparty libs
if (DEFINED MSVC)
  set (WL_3RDPARTY_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty" CACHE STRING "Widelands 3rdparty dir")
  set (CMAKE_INCLUDE_PATH "${WL_3RDPARTY_DIR}/include;${WL_3RDPARTY_DIR}/include/sdl")
  set (CMAKE_LIBRARY_PATH "${WL_3RDPARTY_DIR}/lib")

  add_definitions( -Dand=&& -Dor=|| -Dnot=! -Dxor=^ )
  add_definitions( -Dstrcasecmp=_stricmp )
  add_definitions( -Dstrncasecmp=_strnicmp )
  add_definitions( -Dsnprintf=_snprintf )
  add_definitions( -Drint=floor )
  add_definitions( -Dstrtoll=_strtoi64 )
  add_definitions( -Dstrtoull=_strtoui64 )
  add_definitions( -DNOMINMAX -D_CRT_SECURE_NO_WARNINGS )
  add_definitions( -Dssize_t=size_t )
  add_definitions( -Dmkdir=_mkdir )
  add_definitions( -DREDIRECT_OUTPUT )

  # Automatic linking for boost requires setting lib dir and clearing Boost_LIBARIES
  LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
  set(Boost_LIBRARIES "")
  include_directories(${Boost_INCLUDE_DIR})


  find_library(INTL_LIBRARY NAMES intl libintl)

  set (MSVC_DISABLE_WARNINGS "/wd4290 /wd4800 /wo4373 /wd4355")
  # CMAKE only defines "-g", but we need -DDEBUG also, and we need -DNOPARACHUTE (for SDL) in Debug
  set (CMAKE_CXX_FLAGS_DEBUG " -DDEBUG -DNOPARACHUTE /MTd /Zi /D_DEBUG ${MSVC_DISABLE_WARNINGS}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)

  # CMAKE defines "-O3 -DNDEBUG", but we better say -O2 (see gcc manual)
  set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG /MT /GL ${MSVC_DISABLE_WARNINGS}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)

  set (CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /LTCG /NODEFAULTLIB:libcmt.lib" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)

else (DEFINED MSVC)

=== po/CMakeLists.txt ===
if (${CMAKE_BUILD_TYPE} STREQUAL Release)
  add_custom_target (
    lang ALL
  )
else (${CMAKE_BUILD_TYPE} STREQUAL Release)
  add_custom_target (
    lang_dummy ALL
    COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/locale
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )
  add_custom_target (
    lang
  )
endif (${CMAKE_BUILD_TYPE} STREQUAL Release)

macro(CreateLocale locale_name)
  set (commands "")
  file (GLOB_RECURSE pofiles *.po)
  foreach (pofile ${pofiles})
    get_filename_component(pofile_name ${pofile} NAME_WE)
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" pofile_subpath ${pofile})
    get_filename_component(pofile_path ${pofile} PATH)
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" template_name ${pofile_path})
    if (${pofile_name} STREQUAL ${locale_name})
      add_custom_command (
	OUTPUT ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo
	COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES
	COMMAND msgmerge -q --no-wrap ${pofile} ${CMAKE_CURRENT_SOURCE_DIR}/${template_name}/${template_name}.pot -o ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
	COMMAND msgfmt -o ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
	COMMAND cmake -E remove ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
        DEPENDS ${pofile}
        COMMENT "Generating translations for locale ${locale_name} category ${template_name}"
      )
      list(APPEND commands ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo)
    endif (${pofile_name} STREQUAL ${locale_name})
  endforeach (pofile ${pofiles})
  add_custom_target (
    translang_${locale_name}
    DEPENDS ${commands}
  )
  add_custom_target (
    lang_${locale_name}
    COMMAND cmake -Dlang=${locale_name} -Dpobasedir=${CMAKE_CURRENT_SOURCE_DIR} -Dlocalebasedir=${CMAKE_BINARY_DIR}/locale -P ${CMAKE_CURRENT_SOURCE_DIR}/CheckLocale.cmake
    COMMENT "Checking translations for locale ${locale_name}"
  )
  add_dependencies(lang lang_${locale_name})
  add_dependencies(lang_${locale_name} translang_${locale_name})
endmacro(CreateLocale locale_name)

set (languages_found "")
if (DEFINED WL_LINGUAS AND NOT WL_LINGUAS STREQUAL "")
  set(languages_found ${WL_LINGUAS})
else (DEFINED WL_LINGUAS AND NOT WL_LINGUAS STREQUAL "")
  file (GLOB_RECURSE pofiles *.po)
  foreach(pofile ${pofiles})
    get_filename_component(pofile ${pofile} NAME_WE)
    list(APPEND languages_found ${pofile})
  endforeach(pofile ${pofiles})

  list(SORT languages_found)
  list(REMOVE_DUPLICATES languages_found)
endif (DEFINED WL_LINGUAS AND NOT WL_LINGUAS STREQUAL "")

foreach(language ${languages_found})
  CreateLocale(${language})
endforeach(language ${languages_found})

=== src/CMakeLists.txt ===
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/build_info.cc.cmake ${CMAKE_CURRENT_BINARY_DIR}/build_info.cc)

IF (WIN32)
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../utils/win32/msvc/widelands.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/widelands.rc)
  if (NOT WL_VERSION_MAJOR OR WL_VERSION_MAJOR STREQUAL "")
    set (WL_VERSION_MAJOR 0)
  endif (NOT WL_VERSION_MAJOR OR WL_VERSION_MAJOR STREQUAL "")
  if (NOT WL_VERSION_MINOR OR WL_VERSION_MINOR STREQUAL "")
    set (WL_VERSION_MINOR 15)
  endif (NOT WL_VERSION_MINOR OR WL_VERSION_MINOR STREQUAL "")
  if (NOT WL_VERSION_PATCH OR WL_VERSION_PATCH STREQUAL "")
    set (WL_VERSION_PATCH 1)
  endif (NOT WL_VERSION_PATCH OR WL_VERSION_PATCH STREQUAL "")
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../utils/win32/msvc/Widelands-msvc.iss.cmake ${CMAKE_CURRENT_BINARY_DIR}/Widelands-msvc.iss)
  IF (MINGW)
	set(WIN32_ICON_O ${CMAKE_CURRENT_BINARY_DIR}/wl_icon.o)
	ADD_CUSTOM_COMMAND( OUTPUT ${WIN32_ICON_O}
		COMMAND ${MINGW_PREFIX}windres
			-o${WIN32_ICON_O}
			-i${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	ENDIF (MINGW)
endif (WIN32)

file(GLOB_RECURSE WL_SRCS_CC *.cc)
file(GLOB_RECURSE WL_SRCS_H *.h)
file(GLOB_RECURSE WL_SRCS_CPP *.cpp)

#convention: any directory called "test" contains test sources, including subdirectories
set(WL_TEST_SRCS "")
set(WL_CODECHECK_SRCS "")
foreach (sourcefile ${WL_SRCS_CC} ${WL_SRCS_H})
  if (${sourcefile} MATCHES ".*/test/.*")
    list (APPEND WL_TEST_SRCS ${sourcefile})
    list (REMOVE_ITEM WL_SRCS_CC ${sourcefile})
    list (REMOVE_ITEM WL_SRCS_H ${sourcefile})
  endif (${sourcefile} MATCHES ".*/test/.*")
  # exclude test sources from Codecheck, as well as the scripting/pdep sources from lua
  if (NOT ${sourcefile} MATCHES ".*/scripting/pdep/.*" AND NOT ${sourcefile} MATCHES ".*/test/.*")
    list (APPEND WL_CODECHECK_SRCS ${sourcefile})
  endif (NOT ${sourcefile} MATCHES ".*/scripting/pdep/.*" AND NOT ${sourcefile} MATCHES ".*/test/.*")
endforeach (sourcefile ${WL_SRCS_CC} ${WL_SRCS_H})
foreach (sourcefile ${WL_SRCS_CPP})
  list (APPEND WL_CODECHECK_SRCS ${sourcefile})
endforeach (sourcefile ${WL_SRCS_CPP})
#convention: main.cc should be removed from all lists
list (REMOVE_ITEM WL_SRCS_CC "${CMAKE_CURRENT_SOURCE_DIR}/main.cc")

IF (DEFINED MSVC)
  add_executable (widelands ${GUI_TYPE} main.cc build_info.cc widelands.rc)
else (DEFINED MSVC)
  if (DEFINED MINGW)
    add_executable (widelands ${GUI_TYPE} main.cc build_info.cc ${WIN32_ICON_O})
  else (DEFINED MINGW)
    add_executable (widelands ${GUI_TYPE} main.cc build_info.cc)
  endif (DEFINED MINGW)
endif (DEFINED MSVC)

add_library (widelands_all STATIC ${WL_SRCS_CC} ${WL_SRCS_H})

set (WL_SOURCES_ROOT ${CMAKE_CURRENT_SOURCE_DIR})
set (WL_SOURCES_BINARY_ROOT ${CMAKE_CURRENT_BINARY_DIR})

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/CppCheckSuppressions.cmake ${CMAKE_CURRENT_BINARY_DIR}/CppCheckSuppressions)

if (CMAKE_BUILD_TYPE STREQUAL Debug)
  set (commands "")
  foreach(sourcefile ${WL_CODECHECK_SRCS})
    string(REPLACE "${CMAKE_SOURCE_DIR}/src/" "" sourcewithoutpath ${sourcefile})
    string(REGEX REPLACE "\\.|\\/" "_" sourcenoslash ${sourcewithoutpath})
    if (WIN32)
      string(REGEX REPLACE "^.*:" "" sourcenoslash ${sourcenoslash})
    endif (WIN32)
    get_filename_component(sourcename ${sourcefile} NAME)
    set(stamp ${sourcename}_)
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/codecheck_${sourcenoslash}"
      COMMAND ${CMAKE_COMMAND} -DWL_SOURCE_CHECKER=${CMAKE_SOURCE_DIR}/cmake/codecheck/CodeCheck.py -Dsourcefile=${sourcefile} -DCMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR} -Dstamp=codecheck_${sourcenoslash} -P ${CMAKE_SOURCE_DIR}/src/CodeCheck.cmake
      DEPENDS ${sourcefile}
      COMMENT "Checking ${sourcewithoutpath} with CodeCheck"
    )
    list(APPEND commands ${CMAKE_CURRENT_BINARY_DIR}/codecheck_${sourcenoslash})
    if (WL_EXTRAWARNINGS)
      add_custom_command(
	OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cppcheck_${sourcenoslash}"
	COMMAND ${CMAKE_COMMAND} -DWL_SOURCES_BINARY_ROOT=${WL_SOURCES_BINARY_ROOT} -Dincludedir=${CMAKE_SOURCE_DIR}/src -Dsourcefile=${sourcefile} -DCMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DCMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR} -Dstamp=cppcheck_${sourcenoslash} -P ${CMAKE_SOURCE_DIR}/src/CppCheck.cmake
	DEPENDS ${sourcefile}
	COMMENT "Checking ${sourcewithoutpath} with CppCheck"
      )
      list(APPEND commands ${CMAKE_CURRENT_BINARY_DIR}/cppcheck_${sourcenoslash})
#        set_source_files_properties(${sourcefile} PROPERTIES OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/codecheck_${stamp};${CMAKE_CURRENT_BINARY_DIR}/cppcheck_${stamp}")
    else (WL_EXTRAWARNINGS)
#        set_source_files_properties(${sourcefile} PROPERTIES OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/codecheck_${stamp}")
    endif (WL_EXTRAWARNINGS)
  endforeach(sourcefile ${WL_CODECHECK_SRCS})
  add_custom_target(codecheck DEPENDS ${commands})
  add_dependencies(widelands codecheck)
endif (CMAKE_BUILD_TYPE STREQUAL Debug)

#the subdirectories are only used for test definition
#temporarily disabled the 'old' tests due to incompatibility
#add_subdirectory(economy)
#add_subdirectory(io)
add_subdirectory(scripting)

target_link_libraries(widelands_all ${SDLIMAGE_LIBRARY})
target_link_libraries(widelands_all ${SDLMIXER_LIBRARY})
target_link_libraries(widelands_all ${SDLNET_LIBRARY})
target_link_libraries(widelands_all ${SDLTTF_LIBRARY})
target_link_libraries(widelands_all ${SDLGFX_LIBRARY})
target_link_libraries(widelands_all ${LUA_LIBRARY})
target_link_libraries(widelands_all ${PNG_LIBRARY})
target_link_libraries(widelands_all ${ZLIB_LIBRARY})
target_link_libraries(widelands_all ${GGZ_CORE_LIBRARY})
target_link_libraries(widelands_all ${OPENGL_gl_LIBRARY})
target_link_libraries(widelands_all ${GLEW_LIBRARY})

if (DEFINED WL_EXTRA_LINK_LIBRARIES)
  target_link_libraries(widelands_all ${WL_EXTRA_LINK_LIBRARIES})
endif (DEFINED WL_EXTRA_LINK_LIBRARIES)

target_link_libraries(widelands widelands_all)
target_link_libraries(widelands ${SDL_LIBRARY})

if (APPLE OR WIN32)
  target_link_libraries(widelands_all ${INTL_LIBRARY})
endif (APPLE OR WIN32)

if (WIN32)
  if (DEFINED MSVC)
    target_link_libraries(widelands_all ws2_32)

    #GGZ on MSVC using 3rdparty bundle needs expat and iconv library
    find_package(EXPAT REQUIRED)
    target_link_libraries(widelands_all ${EXPAT_LIBRARY})
    find_library(ICONV_LIBRARY iconv libiconv REQUIRED)
    target_link_libraries(widelands_all ${ICONV_LIBRARY})

  else (DEFINED MSVC)
    target_link_libraries(widelands_all wsock32)
  endif (DEFINED MSVC)
endif (WIN32)

install(TARGETS widelands DESTINATION ${WL_INSTALL_BINDIR} COMPONENT ExecutableFiles)

=== src/economy/test/CMakeLists.txt ===
file(GLOB WL_TEST_ECONOMY_SRCS *.cc)

add_definitions( -DBOOST_TEST_DYN_LINK )

add_executable(test_economy ${WL_TEST_ECONOMY_SRCS})

target_link_libraries(test_economy widelands_all)
target_link_libraries(test_economy ${Boost_LIBRARIES})

add_test(test_economy test_economy)

=== src/scripting/test/CMakeLists.txt ===
file(GLOB WL_SCRIPTING_TEST_SRCS *.cc)

add_executable(test_widelands_scripting ${WL_SCRIPTING_TEST_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/../../build_info.cc)

target_link_libraries(test_widelands_scripting widelands_all)
target_link_libraries(test_widelands_scripting ${Boost_LIBRARIES})

add_test(test_widelands_scripting test_widelands_scripting)

=== utils/win32/mingw/Makefile ===
#####################################################################
#     W I D E L A N D S       M A K E F I L E                       #
#####################################################################
# Do not change this file, instead create a new Makefile.local
# and overwrite the variables listed here

# Use the GGZ Gamingzone? Enable for releases.
ifndef USE_GGZ
USE_GGZ:=NO
endif

# Use of OpenGL?
ifndef OPENGL
OPENGL:=NO
endif


#doxygen
DOXYGEN=/usr/bin/doxygen

#older versions of SDL_mixer don't have RWops-Variants for loading samples and music
ifndef OLD_SDL_MIXER
OLD_SDL_MIXER:=NO
endif

#most current glibc systems implicitly contain libintl.so
IMPLICIT_LIBINTL:=NO

SDL_CONFIG:=sdl-config

# ctags
CTAGS:=/usr/bin/ctags

#ADD_CFLAGS:=-DNO_PARACHUTE


# Different build-types:
#  debug      not optimized, debugging symbols
#  release    optimized
#  profile    optimized, debugging symbols, profiling
#
ifndef BUILD
BUILD:=debug
endif

ifndef CXX
CXX:=g++
endif

TARGET:=native
VERSION:=build16

WINDRES = windres.exe
icon.o: Widelands_win.rc

-include Makefile.local

####################################################################
#  NO USER CHANGES BELOW THIS POINT                                #
####################################################################

ifeq ($(USE_GGZ),YES)
ADD_CFLAGS:= $(ADD_CFLAGS) -DUSE_GGZ
ADD_LDFLAGS:=-lggzmod -lggzcore -lggz -lexpat
endif

ifeq ($(OPENGL),YES)
ADD_CFLAGS:= $(ADD_CFLAGS) -DHAS_OPENGL
endif

##############################################################################
# Flags configuration
BUILD:=$(strip $(BUILD))

ifeq ($(BUILD),release)
OPTIMIZE:=yes
# heavy optimization
ADD_CFLAGS:=$(ADD_CFLAGS) -finline-functions -ffast-math -funroll-loops -funroll-all-loops -fexpensive-optimizations
else
ifeq ($(BUILD),profile)
OPTIMIZE:=yes
DEBUG:=yes
PROFILE:=yes
else
ifeq ($(BUILD),debug)
DEBUG:=yes
endif
endif
endif

ifdef OPTIMIZE
#fix bug with mingw/gcc under windows. revert back to -O3 after(if ever) gcc is fixed
#ADD_CFLAGS += -O3 -fno-tree-ch
endif

ifdef DEBUG
ADD_CFLAGS += -g -DDEBUG  -fmessage-length=0
else
ADD_CFLAGS += -DNDEBUG
endif

ifdef PROFILE
ADD_CFLAGS += -pg -fprofile-arcs
endif

ifeq ($(OLD_SDL_MIXER),YES)
ADD_CFLAGS += -DOLD_SDL_MIXER
endif

ifeq ($(IMPLICIT_LIBINTL),NO)
ADD_LDFLAGS += -lintl
endif

##############################################################################
# Object files and directories, final compilation flags

OBJECT_DIR:=../../$(TARGET)-$(BUILD)
CFLAGS:=-Wall $(shell $(SDL_CONFIG) --cflags) $(ADD_CFLAGS)
CXXFLAGS:=$(CFLAGS)
LDFLAGS:=$(shell $(SDL_CONFIG) --libs) icon.o $(ADD_LDFLAGS) -lz -lpng -lSDL_image -lSDL_mixer -lSDL_ttf -lSDL_net -lSDL_gfx -lwsock32 -llua

##############################################################################
# Building
all: win32tool makedirs tags $(OBJECT_DIR)/widelands.exe
	cp -r $(OBJECT_DIR)/widelands.exe ../../../
	@echo
	@echo "    Congratulations. Build seems to be completed without error."

clean:
	@-rm -rf ../../../widelands.exe
	@-rm -rf ../../../*.da ../../../src/*.da
	@-rm -rf $(OBJECT_DIR)/*.o $(OBJECT_DIR)/*/*.o $(OBJECT_DIR)/*/*/*.o $(OBJECT_DIR)/*/*/*/*.o
	@-rm -rf $(OBJECT_DIR)/*.d $(OBJECT_DIR)/*/*.d $(OBJECT_DIR)/*/*/*.d $(OBJECT_DIR)/*/*/*/*.d
	@-rm -rf $(OBJECT_DIR)/widelands.exe
	@-rm -rf ../../../*~ ../../../*/*~ ../../../*/*/*~ ../../../*/*/*/*~ ../../../*/*/*/*/*~

doc: $(SRC) $(HEADERS)
	@doxygen Doxyfile

dist:
	@rm -rf ../../../widelands-$(VERSION)
	@mkdir ../../../widelands-$(VERSION)
	@cp -r ../../../campaigns ../../../doc ../../../fonts ../../../game_server ../../../locale ../../../maps ../../../music ../../../pics ../../../sound ../../../tribes ../../../txts ../../../worlds ../../../ChangeLog ../../../COPYING ../../../CREDITS ../../../widelands.exe ../../../widelands-$(VERSION)
	@find ../../../widelands-$(VERSION) -name .svn | xargs rm -rf
	@find ../../../widelands-$(VERSION) -name .cvsignore | xargs rm -f
	@echo "    Your build was exported to widelands-$(VERSION)"
	@echo
	@echo "         THE WIDELANDS DEVELOPMENT TEAM            "

# WIDELANDS MAIN PROGRAM BUILD RULES

SUBDIRS  = ../../../src ../../../src/io ../../../src/io/filesystem ../../../src/network ../../../src/economy ../../../src/ai ../../../src/ui_fsmenu
SUBDIRS += ../../../src/ui_basic ../../../src/editor ../../../src/editor/ui_menus ../../../src/editor/tools ../../../src/events ../../../src/sound
SUBDIRS += ../../../src/trigger ../../../src/map_io ../../../src/wui ../../../src/logic ../../../src/profile ../../../src/graphic ../../../src/game_io
SUBDIRS += ../../../src/scripting
CFLAGS += $(patsubst %,-I%,$(SUBDIRS))
CXXFLAGS += $(patsubst %,-I%,$(SUBDIRS))
SRC := $(foreach dir,$(SUBDIRS),$(wildcard $(dir)/*.cc))
HEADERS := $(foreach dir,$(SUBDIRS),$(wildcard $(dir)/*.h))
OBJ := $(patsubst ../../../src/%.cc,$(OBJECT_DIR)/%.o$,$(SRC))
DEP := $(OBJ:.o=.d)

Q = @

makedirs:
	$(Q)-mkdir -p $(OBJECT_DIR) $(patsubst ../../../src/%,$(OBJECT_DIR)/%,$(SUBDIRS))

$(OBJECT_DIR)/widelands.exe: $(OBJ)
	@echo "===> LD $@"
	$(Q)$(CXX) $(OBJ) -o $@ $(LDFLAGS) $(CFLAGS)

-include $(DEP)

$(OBJECT_DIR)/%.o: ../../../src/%.cc
	@echo "===> CXX $<"
	$(Q)$(CXX) -pipe $(CXXFLAGS) -MMD -MP -MF $@.d -c -o $@ $<
	$(Q)sed -e 's@^\(.*\)\.o:@\1.d \1.o:@' $@.d > $(OBJECT_DIR)/$*.d
	$(Q)rm $@.d

tags: $(SRC) $(HEADERS)
	@ if [ -x $(CTAGS) ]; then $(CTAGS) $(SRC) $(HEADERS) 2>/dev/null|| true ; else true; fi

win32tool:
	@echo "===> Creating icon.o for win32"
	@$(WINDRES) -i Widelands_win.rc --input-format=rc -o icon.o -O coff
	@echo "===> Copying configuration files to \"src\""
	@rm -rf ../../../src/config.h
	@cp -r ./config.h ../../../src
	@rm -rf ../../../src/build_info.cc
	@cp -r ./build_info.cc ../../../src
	@rm -rf ../../../src/wlversion.h
	@cp -r ./wlversion.h ../../../src
	@touch ../../../src/build_info.cc

=== src/io/filesystem/test/CMakeLists.txt ===
file(GLOB WL_TEST_IO_FILESYSTEM_SRCS *.cc)

add_definitions( -DBOOST_TEST_DYN_LINK )

add_executable(test_io_filesystem ${WL_TEST_IO_FILESYSTEM_SRCS})

target_link_libraries(test_io_filesystem widelands_all)
target_link_libraries(test_io_filesystem ${Boost_LIBRARIES})

add_test(test_io_filesystem test_io_filesystem)

=== debian/control ===
Source: widelands
Section: games
Priority: extra
Maintainer: Martin Quinson <mquinson@debian.org> 
Uploaders: Enrico Tassi <gareuselesinge@debian.org> 
Standards-Version: 3.9.1
Build-Depends: debhelper (>= 7.0.50~), libsdl1.2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libsdl-net1.2-dev, libsdl-mixer1.2-dev, libsdl-gfx1.2-dev, python, libboost-dev | libboost1.35-dev, libboost-program-options-dev | libboost-program-options1.35-dev, libggz-dev, libggzmod-dev, scons (>= 1.0.1), doxygen, cmake, liblua5.1-dev, libglew1.5-dev
Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/widelands/
Vcs-Browser: http://svn.debian.org/viewsvn/collab-maint/deb-maint/widelands/
Homepage: http://www.widelands.org

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}, ttf-freefont
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: ttf-freefont, ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-dbg
Architecture: any
Section: debug
Depends: widelands (= ${binary:Version}), ${misc:Depends}
Description: fantasy real-time strategy game (debug cruft)
 This package contains the debugging symbols associated to widelands.
 .
 If you don't want to debug widelands (nor report bugs against it), you
 don't need it.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	mkdir -p build-debian
	cd build-debian; cmake \
		-DWL_INSTALL_PREFIX=/usr \
		-DWL_INSTALL_DATADIR=share/games/widelands \
		-DWL_INSTALL_BINDIR=games \
		-DWL_INSTALL_LOCALEDIR=share/games/widelands/locale \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_INSTALL_DATADIR=share/games/widelands \
		-DCMAKE_INSTALL_BINDIR=games \
		-DCMAKE_INSTALL_LOCALEDIR=share/games/widelands/locale \
		-DCMAKE_BUILD_TYPE=Release \
		../; cat src/config.h
		#-DWL_VERSION_MAJOR=0 \
		#-DWL_VERSION_MINOR=16 \
		#-DWL_VERSION_ADDITION=0 \

override_dh_auto_build:
	cd build-debian; make all

override_dh_auto_install:
	cd build-debian; make install DESTDIR=`pwd`/../debian/tmp
	mkdir -p  debian/tmp/usr/share/applications/
	cp debian/widelands.desktop debian/tmp/usr/share/applications/
	rm debian/tmp/usr/share/games/widelands/fonts/FreeSans.ttf
	rm debian/tmp/usr/share/games/widelands/fonts/FreeSerif.ttf
	rm debian/tmp/usr/share/games/widelands/fonts/Widelands/LICENSE
	cd debian/tmp/usr/share/games/widelands/fonts/; ln -s /usr/share/fonts/truetype/freefont/FreeSans.ttf 
	cd debian/tmp/usr/share/games/widelands/fonts/; ln -s /usr/share/fonts/truetype/freefont/FreeSerif.ttf 

override_dh_strip:
	dh_strip --dbg-package=widelands-dbg

## widelands 17

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	# "Build${WL_VERSION_MINOR}" + ".${WL_VERSION_PATCH}" if WL_VERSION_PATCH is
 	# defined.
 	set (WL_VERSION_MAJOR 0)
-	set (WL_VERSION_MINOR 15)
+	set (WL_VERSION_MINOR 17)
 
 	# Just define in case that we release patches for official builds
 	#set (WL_VERSION_PATCH 90)
@@ -107,15 +107,18 @@
 # unit_test_framework is for testing only
 if (WL_UNIT_TESTS)
   message(STATUS "Enabled unit tests")
-
+if (DEFINED MSVC)
   set (BUILD_SHARED_LIBS OFF)
-  set (Boost_FIND_COMPONENTS unit_test_framework)
-  set (Boost_USE_STATIC_LIBS   ON)
+else (DEFINED MSVC)
+  set (Boost_USE_STATIC_LIBS  OFF)
+endif (DEFINED MSVC)
+  set (Boost_FIND_COMPONENTS unit_test_framework signals)
   set (Boost_USE_MULTITHREADED ON)
   set (Boost_DETAILED_FAILURE_MSG ON)
-  find_package(Boost 1.35.0 COMPONENTS unit_test_framework REQUIRED)
+  find_package(Boost 1.35.0 COMPONENTS unit_test_framework signals REQUIRED)
 
   if (NOT DEFINED MSVC)
+  # If boost unit test library is linked dynamically, BOOST_TEST_DYN_LINK must be defined
     string( REGEX MATCH ".a$" BOOST_STATIC_UNIT_TEST_LIB ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
     if (NOT BOOST_STATIC_UNIT_TEST_LIB)
       add_definitions(-DBOOST_TEST_DYN_LINK)
@@ -132,11 +135,15 @@
   add_custom_target(autotest ALL
     COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-    DEPENDS widelands;test_widelands_scripting
+    DEPENDS widelands;test_widelands_scripting;test_economy;test_io_filesystem
   )
 else (WL_UNIT_TESTS)
   message(STATUS "Disabled Unit Tests")
-  find_package(Boost 1.35.0 REQUIRED)
+  set (Boost_FIND_COMPONENTS signals)
+  set (Boost_USE_STATIC_LIBS   ON)
+  set (Boost_USE_MULTITHREADED ON)
+  set (Boost_DETAILED_FAILURE_MSG ON)
+  find_package(Boost 1.35.0 COMPONENTS signals REQUIRED)
 endif (WL_UNIT_TESTS)
 
 option (WL_STRICT "If strict compilation mode is requested (almost every warning is an error)" OFF)
@@ -203,8 +210,23 @@
 # CMAKE only defines "-g", but we need -DDEBUG also, and we need -DNOPARACHUTE (for SDL) in Debug
 set (CMAKE_CXX_FLAGS_DEBUG "-g -DDEBUG -DNOPARACHUTE${WL_COMPILERFLAG_OLDSTYLECAST}${WL_COMPILERFLAG_GENERICWARNINGS}${WL_COMPILERFLAG_EXTRAWARNINGS}${WL_COMPILERFLAG_STRICT}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
 
-# CMAKE defines "-O3 -DNDEBUG", but we better say -O2 (see gcc manual)
-set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
+#This can be removed if no one uses gcc 4.5.1 or 4.5.2 any more
+IF (${CMAKE_COMPILER_IS_GNUCXX})
+EXEC_PROGRAM (
+    ${CMAKE_CXX_COMPILER}
+    ARGS --version
+    OUTPUT_VARIABLE WLBUILD_COMPILERVERSION
+    )
+    STRING(REGEX REPLACE ".*(4)\\.(5)\\.([0-9]).*" "\\1.\\2.\\3" WLBUILD_COMPILERVERSION_REP ${WLBUILD_COMPILERVERSION})
+    IF (WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.1" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.2")
+        message("Detected gcc ${WLBUILD_COMPILERVERSION_REP}")
+        message("Suffering from gcc bug, disabling -O3")
+        set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
+    ELSE (WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.1" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.2")
+        #This line is the default and should be preserved.
+        set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
+    ENDIF (WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.1" OR WLBUILD_COMPILERVERSION_REP STREQUAL "4.5.2")
+ENDIF (${CMAKE_COMPILER_IS_GNUCXX})
 
 #If building with MSVC, then check for 3rdparty libs
 if (DEFINED MSVC)
@@ -217,28 +239,3 @@
   add_definitions( -Dstrncasecmp=_strnicmp )
   add_definitions( -Dsnprintf=_snprintf )
   add_definitions( -Drint=floor )
-  add_definitions( -Dstrtoll=_strtoi64 )
-  add_definitions( -Dstrtoull=_strtoui64 )
-  add_definitions( -DNOMINMAX -D_CRT_SECURE_NO_WARNINGS )
-  add_definitions( -Dssize_t=size_t )
-  add_definitions( -Dmkdir=_mkdir )
-  add_definitions( -DREDIRECT_OUTPUT )
-
-  # Automatic linking for boost requires setting lib dir and clearing Boost_LIBARIES
-  LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
-  set(Boost_LIBRARIES "")
-  include_directories(${Boost_INCLUDE_DIR})
-
-
-  find_library(INTL_LIBRARY NAMES intl libintl)
-
-  set (MSVC_DISABLE_WARNINGS "/wd4290 /wd4800 /wo4373 /wd4355")
-  # CMAKE only defines "-g", but we need -DDEBUG also, and we need -DNOPARACHUTE (for SDL) in Debug
-  set (CMAKE_CXX_FLAGS_DEBUG " -DDEBUG -DNOPARACHUTE /MTd /Zi /D_DEBUG ${MSVC_DISABLE_WARNINGS}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
-
-  # CMAKE defines "-O3 -DNDEBUG", but we better say -O2 (see gcc manual)
-  set (CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG /MT /GL ${MSVC_DISABLE_WARNINGS}" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
-
-  set (CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /LTCG /NODEFAULTLIB:libcmt.lib" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
-
-else (DEFINED MSVC)

=== utils/win32/mingw/Makefile ===
--- 
+++ 
@@ -3,11 +3,6 @@
 #####################################################################
 # Do not change this file, instead create a new Makefile.local
 # and overwrite the variables listed here
-
-# Use the GGZ Gamingzone? Enable for releases.
-ifndef USE_GGZ
-USE_GGZ:=NO
-endif
 
 # Use of OpenGL?
 ifndef OPENGL
@@ -48,7 +43,7 @@
 endif
 
 TARGET:=native
-VERSION:=build16
+VERSION:=build17
 
 WINDRES = windres.exe
 icon.o: Widelands_win.rc
@@ -58,11 +53,6 @@
 ####################################################################
 #  NO USER CHANGES BELOW THIS POINT                                #
 ####################################################################
-
-ifeq ($(USE_GGZ),YES)
-ADD_CFLAGS:= $(ADD_CFLAGS) -DUSE_GGZ
-ADD_LDFLAGS:=-lggzmod -lggzcore -lggz -lexpat
-endif
 
 ifeq ($(OPENGL),YES)
 ADD_CFLAGS:= $(ADD_CFLAGS) -DHAS_OPENGL

=== src/io/filesystem/test/CMakeLists.txt ===
file(GLOB WL_TEST_IO_FILESYSTEM_SRCS *.cc)

add_executable(test_io_filesystem ${WL_TEST_IO_FILESYSTEM_SRCS} ${TEST_EXTRA_SOURCES})

target_link_libraries(test_io_filesystem widelands_all)
target_link_libraries(test_io_filesystem ${Boost_LIBRARIES})
target_link_libraries(test_io_filesystem ${TEST_EXTRA_LIBS})

add_test(test_io_filesystem test_io_filesystem)

=== debian/control ===
Source: widelands
Section: games
Priority: extra
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: 
  Martin Quinson <mquinson@debian.org>,
  Enrico Tassi <gareuselesinge@debian.org> 
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9), 
  libsdl1.2-dev, 
  libsdl-image1.2-dev, 
  libsdl-ttf2.0-dev, 
  libsdl-net1.2-dev, 
  libsdl-mixer1.2-dev, 
  libsdl-gfx1.2-dev, 
  python, 
  libboost-dev | libboost1.49-dev, 
  libboost-signals-dev | libboost1.49-signals-dev, 
  doxygen, 
  cmake, 
  imagemagick,
  liblua5.1-dev, 
  libglew1.5-dev, 
  libpng-dev, 
  zlib1g-dev
Vcs-Git: git://git.debian.org/git/pkg-games/widelands.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/widelands.git
#Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/widelands/ <-- Old location of packaging
Homepage: http://www.widelands.org/

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}), 
  ${shlibs:Depends}, 
  ${misc:Depends}, 
  ttf-freefont
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: ttf-freefont, 
  ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-dbg
Architecture: any
Section: debug
Depends: widelands (= ${binary:Version}), 
 ${misc:Depends}
Description: fantasy real-time strategy game (debug cruft)
 This package contains the debugging symbols associated to widelands.
 .
 If you don't want to debug widelands (nor report bugs against it), you
 don't need it.

=== debian/rules ===
#!/usr/bin/make -f

# parallel building
parallel=$(shell echo $$DEB_BUILD_OPTIONS | grep parallel > /dev/null && echo -j$$(test -f /proc/cpuinfo && cat /proc/cpuinfo | (grep ^processor || echo 1) | wc -l))

# Hardening flags
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	mkdir -p build-debian
	cd build-debian && cmake \
		-DWL_INSTALL_PREFIX=/usr \
		-DWL_INSTALL_DATADIR=share/games/widelands \
		-DWL_INSTALL_BINDIR=games \
		-DWL_INSTALL_LOCALEDIR=/usr/share/games/widelands/locale \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		../ && cat src/config.h

override_dh_auto_build:
	cd build-debian && make VERBOSE=1 ${parallel}

override_dh_auto_install:
	cd build-debian && make install DESTDIR=`pwd`/../debian/tmp
	mkdir -p  debian/tmp/usr/share/applications/
	cp debian/widelands.desktop debian/tmp/usr/share/applications/
	# Take care of the fonts (use system-wide ones)
	rm debian/tmp/usr/share/games/widelands/fonts/FreeSans.ttf
	rm debian/tmp/usr/share/games/widelands/fonts/FreeSerif.ttf
	rm debian/tmp/usr/share/games/widelands/fonts/Widelands/LICENSE
	cd debian/tmp/usr/share/games/widelands/fonts/; ln -s /usr/share/fonts/truetype/freefont/FreeSans.ttf 
	cd debian/tmp/usr/share/games/widelands/fonts/; ln -s /usr/share/fonts/truetype/freefont/FreeSerif.ttf
	# Take care of the logo
	for size in 16 32 48 64 128 ; do \
	  mkdir -p debian/widelands/usr/share/icons/hicolor/$${size}x$${size}/apps ; \
	  cp debian/tmp/usr/share/games/widelands/pics/wl-ico-$${size}.png \
	     debian/widelands/usr/share/icons/hicolor/$${size}x$${size}/apps/widelands.png; \
	done
	convert debian/widelands/usr/share/icons/hicolor/32x32/apps/widelands.png \
	        debian/widelands/usr/share/icons/hicolor/32x32/apps/widelands.xpm

override_dh_install:
	dh_install --list-missing

override_dh_strip:
	dh_strip --dbg-package=widelands-dbg
